(function(msgMgr){"use strict";const Cc=Components.classes;const Ci=Components.interfaces;const Cu=Components.utils;const XUL_NS="http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul";const HTML_NS="http://www.w3.org/1999/xhtml";const iCloudHostname="www.icloud.com";const GDocsHostname="docs.google.com";const ZohoHostname="docs.zoho.com";
const syllableOverlayLifetime=1000 ;const isChrome=typeof window==="object";let AVIMConfig;if(isChrome)AVIMConfig=avim.onFrameReadyForPrefs();else{let results=sendSyncMessage("AVIM:readyforprefs");if(results)AVIMConfig=results[0];addMessageListener("AVIM:prefschanged",function(msg){ AVIMConfig=msg.data;});}
const wordChars="\u0400-\u052f\u2de0-\u2dff\ua640-\ua69f"+"\u0370-\u03ff\u1f00-\u1fff"+"A-Za-zÀ-ÖØ-öø-\u02af\u1d00-\u1dbf\u1e00-\u1eff\u2c60-\u2c7f"+"\ua720-\ua7ff\uab30-\uab6f\ufb00-\ufb4f"+"\u0600-\u06ff\u0750-\u077f\u08a0-\u08ff\ufb50-\ufdff\ufe70-\ufeff"+"\u0590-\u05ff\ufb1d-\ufb40"+"\u0900-\u097f\u1cd0-\u1cff"+"\u02b0-\u02ff"+"0-9"+"₫\u0303"+"’";const wordRe=new RegExp("["+wordChars+"]*$");function quoteJS(str){return"\""+str.replace(/\\/g,"\\\\").replace(/[\b]/g,"\\b").replace(/\f/g,"\\f").replace(/\n/g,"\\n").replace(/\r/g,"\\r").replace(/\t/g,"\\t").replace(/\v/g,"\\v").replace(/"/g,"\\\"")+"\"";}
function methodIsVIQR(){if(AVIMConfig.method>2)return true;return AVIMConfig.method===0&&(AVIMConfig.autoMethods.viqr||AVIMConfig.autoMethods.viqrStar);}
function lastWordInString(str){if(!str)return"";if(str.substr(-1)==="\\"&&methodIsVIQR())return"\\";let match=wordRe.exec(str);return match&&match[0];}
const subscriptLoader=Cc["@mozilla.org/moz/jssubscript-loader;1"].getService(Ci.mozIJSSubScriptLoader);function loadSubScript(uri,target){if("loadSubScriptWithOptions"in subscriptLoader){let options={charset:"UTF-8",};if(target)options.target=target;subscriptLoader.loadSubScriptWithOptions(uri,options);}
else subscriptLoader.loadSubScript(uri,target,"UTF-8");}
function Sandbox(principal){let sandbox=new Cu.Sandbox(principal,{sandboxName:"avim",sandboxPrototype:principal,wantXrays:false,});if(!sandbox)throw"No sandbox to evaluate in.";const jsVersion="1.7";const evalInBox=Cu.evalInSandbox;this.evalBoolean=function(text){return evalInBox("!!("+text+")",sandbox,jsVersion);};

this.createObjectAlias=function(name,text){sandbox[name]=evalInBox("("+text+")||undefined",sandbox,jsVersion);return sandbox[name]!==undefined;};this.importFunction=function(fn,name){sandbox.importFunction(fn,name);};this.injectScript=function(uri){loadSubScript(uri,sandbox);};this.nuke=function(){if("nukeSandbox"in Cu)Cu.nukeSandbox(sandbox);sandbox=null;};}
function getEditor(el){if(!el)return null;let editor;try{editor=el.QueryInterface(Ci.nsIDOMNSEditableElement).editor;}
catch(e){}
try{editor=editor||el.QueryInterface(Ci.nsIEditor).editor;}
catch(e){}
try{if(!editor){ let webNavigation=el.QueryInterface(Ci.nsIInterfaceRequestor).getInterface(Ci.nsIWebNavigation);let editingSession=webNavigation.QueryInterface(Ci.nsIInterfaceRequestor).getInterface(Ci.nsIEditingSession);return editingSession.getEditorForWindow(el);}}
catch(e){}
return editor.isDocumentEditable?editor:null;}
function SpliceTxn(outer,node,pos,len,repl){this.wrappedJSObject=this; this.isTransient=false;this.node=node;this.pos=pos;this.len=len;this.repl=repl;let editor=getEditor(outer);let sel=editor&&editor.selection;this.startOffset=sel&&sel.anchorOffset;let isReact=node.ownerDocument.documentElement.id==="facebook";let isOwa=node.baseURI.indexOf(".officeapps.live.com/")>0&&node.ownerDocument.body.id==="MainApp";function getSelection(){let editor=getEditor(outer);return editor&&editor.selection;}
this.shiftSelection=function(numChars){let sel=getSelection();if(sel)sel.collapse(this.node,this.startOffset+numChars);};this.doTransaction=this.redoTransaction=function(){this.orig=this.node.substringData(this.pos,this.len);
if(isReact||isOwa){let sel=getSelection();if(sel){sel.collapse(this.node,this.pos);sel.extend(this.node,this.pos+this.len);}
let win=this.node.ownerDocument.defaultView;let winUtils=win.QueryInterface(Ci.nsIInterfaceRequestor).getInterface(Ci.nsIDOMWindowUtils);for(let i=0;i<this.repl.length;i++){winUtils.sendKeyEvent("keypress",0,this.repl.charCodeAt(i),0);}}
else{this.node.replaceData(this.pos,this.len,this.repl);this.shiftSelection(this.repl.length-this.len);}};this.undoTransaction=function(){this.node.replaceData(this.pos,this.repl.length,this.orig);this.shiftSelection(0);};this.merge=function(aTxn){if(!("wrappedJSObject"in aTxn&&aTxn.wrappedJSObject instanceof SpliceTxn)){return false;}
aTxn=aTxn.wrappedJSObject;if(node!==aTxn.node&&this.pos!==aTxn.pos)return false; this.repl=aTxn.repl;this.len=aTxn.len;this.startOffset=aTxn.startOffset; return true;};this.QueryInterface=function(iid){if(iid===Ci.nsITransaction||iid===Ci.nsISupports)return this;return null;};}
function applyKey(word,evt){let data={prefix:word,evt:{keyCode:evt.keyCode,which:evt.which,shiftKey:evt.shiftKey,},};if(isChrome)return avim.onFrameKeyPress({data:data});let results=sendSyncMessage("AVIM:keypress",data);return results&&results[0];}
function getSelectedNode(editor){let sel=editor&&editor.selection;if(!sel||sel.rangeCount!==1||!sel.isCollapsed)return null;let node=sel.anchorNode;
if(node===editor.rootElement&&sel.anchorOffset){node=node.childNodes[sel.anchorOffset-1];if(node.data)sel.collapse(node,node.data.length);}
return node;}
function splice(outer,evt){let result={};let editor=getEditor(outer);let sel=editor&&editor.selection;let node=getSelectedNode(editor);if(!node||!sel.anchorOffset||!node.data)return result;let word=lastWordInString(node.substringData(0,sel.anchorOffset));let key=String.fromCharCode(evt.which);result=word&&applyKey(word,evt); if(!result||(word&&result.value===word+key))return{};let wordStart=sel.anchorOffset-word.length;if("maxLength"in outer&&outer.maxLength!==-1){result.value=result.value.substr(0,outer.maxLength-wordStart);}
if("value"in result&&result.value!==word){let txn=new SpliceTxn(outer,node,wordStart,word.length,result.value);editor.doTransaction(txn);}
return result;}
const focusMgr=Cc["@mozilla.org/focus-manager;1"]&&Cc["@mozilla.org/focus-manager;1"].getService(Ci.nsIFocusManager);function getEditedNativeElement(){let dispatcher=isChrome?window.document.commandDispatcher:focusMgr;let elt=dispatcher.focusedElement;let doc=dispatcher.focusedWindow.document;let wysiwyg=(doc.designMode&&doc.designMode.toLowerCase()==="on")||(elt.contentEditable&&elt.contentEditable.toLowerCase()==="true");return wysiwyg?new XPCNativeWrapper(doc.defaultView):elt;}
function insertSyllableOverlay(node,word){let win=isChrome?window:msgMgr.content;let doc=win.document;if(!doc)return;let winUtils=win.QueryInterface(Ci.nsIInterfaceRequestor).getInterface(Ci.nsIDOMWindowUtils);if(!("sendQueryContentEvent"in winUtils))return;


let sel=winUtils.sendQueryContentEvent(winUtils.QUERY_SELECTED_TEXT,0,0,0,0);let textRect=winUtils.sendQueryContentEvent(winUtils.QUERY_TEXT_RECT,sel.offset-word.length,word.length,0,0);let scale=1;if("screenPixelsPerCSSPixel"in winUtils){scale/=winUtils.screenPixelsPerCSSPixel;}
let overlay=doc.createElementNS(HTML_NS,"div");overlay.className="avim-syllable-overlay";overlay.style.left=textRect.left*scale+"px";overlay.style.top=textRect.top*scale+"px";overlay.style.width=textRect.width*scale+"px";overlay.style.height=textRect.height*scale+"px";if("getVisitedDependentComputedStyle"in winUtils){
let color=winUtils.getVisitedDependentComputedStyle(node.parentElement,null,"color");overlay.style.outlineColor=color;}

if(doc.documentElement&&doc.documentElement.namespaceURI===XUL_NS){doc.documentElement.appendChild(overlay);setTimeout(function(doc,overlay){if(doc&&doc.documentElement&&overlay){doc.documentElement.removeChild(overlay);}},syllableOverlayLifetime,doc,overlay);}
else if("insertAnonymousContent"in doc){let anonOverlay=doc.insertAnonymousContent(overlay);setTimeout(function(doc,anonOverlay){try{if(doc&&anonOverlay)doc.removeAnonymousContent(anonOverlay);}
catch(exc){}},syllableOverlayLifetime,doc,anonOverlay);}}
function insertSyllableBreak(outer){if(!outer)outer=getEditedNativeElement();let editor=getEditor(outer);let node=getSelectedNode(editor);if(node instanceof Ci.nsIDOMText){let sel=editor.selection;let word=lastWordInString(node.substringData(0,sel.anchorOffset));if(word){insertSyllableOverlay(node,word);let newNode=node.splitText(sel.anchorOffset);sel.collapse(newNode,0);return true;}}
return false;}
function deleteDiacritic(){let outer=getEditedNativeElement();let editor=getEditor(outer);let node=getSelectedNode(editor);if(node instanceof Ci.nsIDOMText){splice(outer,{keyCode:Ci.nsIDOMKeyEvent.DOM_VK_BACK_SPACE,which:Ci.nsIDOMKeyEvent.DOM_VK_BACK_SPACE,shiftKey:true,});}}
function updateContainer(outer,inner){if(!inner)return;if(inner.ownerDocument&&(inner.ownerDocument.location.hostname===iCloudHostname||inner.ownerDocument.location.hostname===GDocsHostname)){return;}
let inputEvent=inner.ownerDocument.createEvent("Events");inputEvent.initEvent("input",true,true);if(inner.dispatchEvent)inner.dispatchEvent(inputEvent); if(outer&&outer.form){let controller=Cc["@mozilla.org/autocomplete/controller;1"].getService(Ci.nsIAutoCompleteController);controller.handleEndComposition();}}
function findIgnore(el){if(!el||!el.getAttribute)return true;let id=el.id||el.getAttribute("id");if(id&&id.toLowerCase&&AVIMConfig.exclude.indexOf(id.toLowerCase())>=0){return true;}
let name=el.name||el.getAttribute("name");if(name&&name.toLowerCase&&AVIMConfig.exclude.indexOf(name.toLowerCase())>=0){return true;}
let win=el.ownerDocument&&el.ownerDocument.defaultView;if(!win||!win.getComputedStyle)return false;let mode=win.getComputedStyle(el,null).getPropertyValue("ime-mode");return mode==="disabled";}
function scrollToCaret(outer){let editor=getEditor(outer);let selCtrlr=editor&&editor.selectionController;if(!selCtrlr)return;selCtrlr.scrollSelectionIntoView(selCtrlr.SELECTION_NORMAL,selCtrlr.SELECTION_FOCUS_REGION,0);}
function handleWysiwyg(evt){let elt=evt.originalTarget;let win=new XPCNativeWrapper(elt.ownerDocument.defaultView);if(findIgnore(elt))return;if(win.frameElement&&findIgnore(win.frameElement))return;if(evt.shiftKey&&evt.which===evt.DOM_VK_SPACE){if(insertSyllableBreak(win)){evt.stopPropagation();evt.preventDefault();}
return;}
let result=splice(win,evt);if(result.changed){evt.stopPropagation();evt.preventDefault();updateContainer(null,elt.ownerDocument.documentElement);scrollToCaret(win);}}
function handleHtmlInput(evt){


const htmlTypes=["search","text","textarea"];let elt=evt.originalTarget; if(findIgnore(evt.target)||!elt.type)return;let isHTML=htmlTypes.indexOf(elt.type)>=0||(elt.type==="password"&&AVIMConfig.passwords)||(elt.type==="url"&&(AVIMConfig.exclude.indexOf("url")<0||AVIMConfig.exclude.indexOf("urlbar")<0))||(elt.type==="email"&&(AVIMConfig.exclude.indexOf("email")<0||AVIMConfig.exclude.indexOf("e-mail")<0));if(!isHTML||elt.selectionStart!==elt.selectionEnd)return;if(evt.shiftKey&&evt.which===evt.DOM_VK_SPACE){if(insertSyllableBreak(elt))evt.preventDefault();return;}
let result=splice(elt,evt);if(result.changed){evt.preventDefault();updateContainer(elt,elt);scrollToCaret(elt);}}
let lazyHandlers={};function handleLazily(evt,scriptName){if(!(scriptName in lazyHandlers)){loadSubScript("chrome://avim/content/"+scriptName+".js",{applyKey:applyKey,lastWordInString:lastWordInString,lazyHandlers:lazyHandlers,});}
return lazyHandlers[scriptName](evt);}
function keyEventString(evt){return[evt.keyCode,evt.which,evt.shiftKey].join(",");}
function safeApplyKey(word,evtProxy){let result=applyKey(word,evtProxy);return JSON.stringify([result.value,result.changed]);}
function handleWithContentScript(elt,evt,scriptName){let sandbox=new Sandbox(elt.ownerDocument.defaultView);sandbox.createObjectAlias("_avim_evtInfo","["+keyEventString(evt)+"]");sandbox.createObjectAlias("_avim_textChanged","false");sandbox.importFunction(lastWordInString,"_avim_lastWordInString");sandbox.importFunction(safeApplyKey,"_avim_applyKey");sandbox.injectScript("chrome://avim/content/editors/"+scriptName+".js");let changed=sandbox.evalBoolean("_avim_textChanged");sandbox.nuke();if(changed){evt.handled=true;evt.stopPropagation();evt.preventDefault();}
return changed;}
const specializedHandlers=[{lazyScriptName:"sciMoz",targetIsIgnorable:true,isTarget:function(origTarget,doc){let koManager=isChrome&&window.ko&&ko.views&&ko.views.manager;let koView=koManager&&koManager.currentView;let scintilla=koView&&koView.scintilla;return scintilla&&scintilla.inputField&&origTarget===scintilla.inputField.inputField;},},{contentScriptName:"trang",isTarget:function(origTarget,doc){return doc.location.hostname===iCloudHostname&&origTarget.isContentEditable;},},{lazyScriptName:"kix",isTarget:function(origTarget,doc){return doc.defaultView.frameElement&&doc.defaultView.parent&&doc.defaultView.parent.location.hostname===GDocsHostname&&origTarget.isContentEditable;},},{contentScriptName:"zwrite",isTarget:function(origTarget,doc){return doc.location.hostname===ZohoHostname&&origTarget.isContentEditable&&doc.getElementsByClassName("zw-page").length;},},{contentScriptName:"zshow",isTarget:function(origTarget,doc){return doc.location.hostname===ZohoHostname&&origTarget.isContentEditable&&doc.getElementsByClassName("slide-parent-overlay").length;},},{contentScriptName:"ymacs",updatesContainer:true,isTarget:function(origTarget,doc){let tagName=origTarget.localName.toLowerCase();return(tagName==="html"||tagName==="body")&&doc.getElementsByClassName("Ymacs-frame-content").length;},},{contentScriptName:"ace",targetsParent:true,targetIsIgnorable:true,updatesContainer:true,isTarget:function(origTarget,doc){let tagName=origTarget.localName.toLowerCase();let parent=origTarget.parentNode;if(tagName!=="textarea")return false;return"classList"in parent&&parent.classList.contains("ace_editor")&&parent.classList.contains("ace_focus")&&"querySelector"in parent.ownerDocument;},},];function getSpecializedHandler(origTarget,doc){for(let i=0;i<specializedHandlers.length;i++){let handler=specializedHandlers[i];if(handler.isTarget(origTarget,doc))return handler;}
return null;}
function handleSpecialized(handler,evt){if(!handler)return;let origTarget=evt.originalTarget;if(handler.targetIsIgnorable&&findIgnore(evt.target))return;if(handler.lazyScriptName)handleLazily(evt,handler.lazyScriptName);else if(handler.contentScriptName){let elt=handler.targetsParent?origTarget.parentNode:origTarget;if(handleWithContentScript(elt,evt,handler.contentScriptName)&&handler.updatesContainer){updateContainer(elt,elt);}}} 
function slightFindIgnore(name){return name.toLowerCase&&AVIMConfig.exclude.indexOf(name.toLowerCase())>=0;}
function registerSlight(plugin){plugin.setAttribute("data-avim-registering","true");try{let sandbox=new Sandbox(plugin.ownerDocument.defaultView);sandbox.importFunction(slightFindIgnore,"_avim_findIgnore");sandbox.importFunction(lastWordInString,"_avim_lastWordInString");sandbox.importFunction(safeApplyKey,"_avim_applyKey");sandbox.injectScript("chrome://avim/content/editors/slight.js");sandbox.nuke();}
catch(exc){}
plugin.removeAttribute("data-avim-registering");}
function registerSlights(){const slightMimeTypes=["application/x-silverlight-1","application/x-silverlight-2","application/ag-plugin"];
addEventListener("PluginInstantiated",function(evt){let plugin=evt.originalTarget;if("querySelectorAll"in plugin.ownerDocument&&plugin instanceof Ci.nsIObjectLoadingContent&&slightMimeTypes.indexOf(plugin.actualType)>=0){registerSlight(plugin);}},true);}
function disableOthers(doc){if(!AVIMConfig.onOff||!AVIMConfig.disabledScripts.enabled)return;if(doc.location.protocol==="chrome:")return;
let winWrapper=new XPCNativeWrapper(doc.defaultView);let win=winWrapper.wrappedJSObject;if(win===undefined||win===null||(isChrome&&win===window)){return;} 
let sandbox=new Sandbox(doc.defaultView);let disabledScriptNames=[];for(let name in AVIMConfig.disabledScripts){if(name&&AVIMConfig.disabledScripts.propertyIsEnumerable(name)&&AVIMConfig.disabledScripts[name]){disabledScriptNames.push(name);}}
sandbox.createObjectAlias("disabledScripts",quoteJS(disabledScriptNames.join("|")));sandbox.injectScript("chrome://avim/content/disabler.js");sandbox.nuke();}
function checkCode(evt){let code=evt.which;return!AVIMConfig.onOff||(code<evt.DOM_VK_INSERT&&code!==evt.DOM_VK_BACK_SPACE&&code!==evt.DOM_VK_PRINT&&code!==evt.DOM_VK_SPACE&&code!==evt.DOM_VK_RIGHT&&code!==evt.DOM_VK_DOWN&&code!==evt.DOM_VK_EXECUTE)||code===evt.DOM_VK_SCROLL_LOCK;}
let isWaitingForShiftSpace=false;addEventListener("keydown",function(evt){ if(evt.shiftKey&&evt.which!==evt.DOM_VK_SPACE){isWaitingForShiftSpace=evt.which===evt.DOM_VK_SHIFT;}
if(evt.ctrlKey||evt.metaKey||evt.altKey||checkCode(evt))return;let doc=evt.target.ownerDocument;if(isChrome&&doc.defaultView===window){doc=evt.originalTarget.ownerDocument;}
disableOthers(doc);},true);addEventListener("keypress",function(evt){ if(evt.ctrlKey||evt.metaKey||evt.altKey||checkCode(evt))return;if(isChrome&&evt.originalTarget.localName==="browser")return;if(!isWaitingForShiftSpace&&evt.shiftKey&&evt.which===evt.DOM_VK_SPACE){return;}
isWaitingForShiftSpace=false;let target=evt.target;let origTarget=evt.originalTarget;if(isChrome&&origTarget.localName==="browser")return;let doc=target.ownerDocument;if(isChrome&&doc.defaultView===window){doc=origTarget.ownerDocument;}
try{let handler=getSpecializedHandler(origTarget,doc);handleSpecialized(handler,evt);}catch(exc){} 
let wysiwyg=(doc.designMode&&doc.designMode.toLowerCase()==="on")||(target.contentEditable&&target.contentEditable.toLowerCase()==="true");if(wysiwyg)handleWysiwyg(evt); else handleHtmlInput(evt);},true);addEventListener("keyup",function(evt){if(evt.which===evt.DOM_VK_SHIFT){isWaitingForShiftSpace=false;}},true);const textEventHandlers={brokesyllable:insertSyllableBreak,deleteddiacritic:deleteDiacritic,};if(isChrome){avim.doTextCommand=function(txtCmd){textEventHandlers[txtCmd]();};}
else{let listener=function(msg){let txtEvt=msg.name.match(/^AVIM:(.+)/)[1];textEventHandlers[txtEvt]();};for(let txtEvt in textEventHandlers){if(textEventHandlers.propertyIsEnumerable(txtEvt)){addMessageListener("AVIM:"+txtEvt,listener);}}}
registerSlights();})(this);